<!DOCTYPE html>

<html lang="en" data-content_root="../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>plot.plot &#8212; plot 0.1.0.post1.dev3+g95a57f2.d20230908 documentation</title>
    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=fa44fd50" />
    <link rel="stylesheet" type="text/css" href="../../_static/alabaster.css?v=233b9934" />
    <script src="../../_static/documentation_options.js?v=3301bed8"></script>
    <script src="../../_static/doctools.js?v=888ff710"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
   
  <link rel="stylesheet" href="../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for plot.plot</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">This is a skeleton file that can serve as a starting point for a Python</span>
<span class="sd">console script. To run this script uncomment the following lines in the</span>
<span class="sd">``[options.entry_points]`` section in ``setup.cfg``::</span>

<span class="sd">    console_scripts =</span>
<span class="sd">         fibonacci = plot.skeleton:run</span>

<span class="sd">Then run ``pip install .`` (or ``pip install -e .`` for editable mode)</span>
<span class="sd">which will install the command ``fibonacci`` inside your current environment.</span>

<span class="sd">Besides console scripts, the header (i.e. until ``logger``...) of this file can</span>
<span class="sd">also be used as template for Python modules.</span>

<span class="sd">Note:</span>
<span class="sd">    This file can be renamed depending on your needs or safely removed if not needed.</span>

<span class="sd">References:</span>
<span class="sd">    - https://setuptools.pypa.io/en/latest/userguide/entry_point.html</span>
<span class="sd">    - https://pip.pypa.io/en/stable/reference/pip_install</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">import</span> <span class="nn">argparse</span>
<span class="kn">import</span> <span class="nn">logging</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>
<span class="kn">import</span> <span class="nn">seaborn</span> <span class="k">as</span> <span class="nn">sns</span>
<span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">from</span> <span class="nn">collections</span> <span class="kn">import</span> <span class="n">namedtuple</span>
<span class="kn">from</span> <span class="nn">io</span> <span class="kn">import</span> <span class="n">BytesIO</span>
<span class="kn">from</span> <span class="nn">itertools</span> <span class="kn">import</span> <span class="n">cycle</span>
<span class="kn">from</span> <span class="nn">matplotlib</span> <span class="kn">import</span> <span class="n">pyplot</span> <span class="k">as</span> <span class="n">plt</span>
<span class="kn">from</span> <span class="nn">pathlib</span> <span class="kn">import</span> <span class="n">Path</span>

<span class="kn">from</span> <span class="nn">plot</span> <span class="kn">import</span> <span class="n">__version__</span>

<span class="n">__author__</span> <span class="o">=</span> <span class="s2">&quot;Branden Kappes&quot;</span>
<span class="n">__copyright__</span> <span class="o">=</span> <span class="s2">&quot;Contextualize LLC&quot;</span>
<span class="n">__license__</span> <span class="o">=</span> <span class="s2">&quot;MIT&quot;</span>

<span class="n">logger</span> <span class="o">=</span> <span class="n">logging</span><span class="o">.</span><span class="n">getLogger</span><span class="p">(</span><span class="vm">__name__</span><span class="p">)</span>
<span class="n">logging</span><span class="o">.</span><span class="n">getLogger</span><span class="p">(</span><span class="s1">&#39;matplotlib.font_manager&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">setLevel</span><span class="p">(</span><span class="n">logging</span><span class="o">.</span><span class="n">ERROR</span><span class="p">)</span>


<div class="viewcode-block" id="RecognizedException">
<a class="viewcode-back" href="../../api/plot.html#plot.plot.RecognizedException">[docs]</a>
<span class="k">class</span> <span class="nc">RecognizedException</span><span class="p">(</span><span class="ne">Exception</span><span class="p">):</span>
    <span class="k">pass</span></div>



<span class="c1"># ---- Python API ----</span>
<span class="c1"># The functions defined in this section can be imported by users in their</span>
<span class="c1"># Python scripts/interactive interpreter, e.g. via</span>
<span class="c1"># `from plot.skeleton import fib`,</span>
<span class="c1"># when using this Python module as a library.</span>

<div class="viewcode-block" id="load_dataframe">
<a class="viewcode-back" href="../../api/plot.html#plot.plot.load_dataframe">[docs]</a>
<span class="k">def</span> <span class="nf">load_dataframe</span><span class="p">(</span><span class="n">args</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;Loads a pandas DataFrame from an input file.&quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="nf">get_reader</span><span class="p">():</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;Return a reader appropriate for the input data.&quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="n">args</span><span class="o">.</span><span class="n">source</span> <span class="o">==</span> <span class="s2">&quot;-&quot;</span> <span class="ow">or</span> <span class="n">args</span><span class="o">.</span><span class="n">ifmt</span> <span class="o">!=</span> <span class="s2">&quot;auto&quot;</span><span class="p">:</span>
            <span class="c1"># If reading from the stdin or if format is given explicitly.</span>
            <span class="k">if</span> <span class="n">args</span><span class="o">.</span><span class="n">source</span> <span class="o">==</span> <span class="s2">&quot;-&quot;</span> <span class="ow">and</span> <span class="n">args</span><span class="o">.</span><span class="n">ifmt</span> <span class="o">==</span> <span class="s2">&quot;auto&quot;</span><span class="p">:</span>
                <span class="k">raise</span> <span class="n">RecognizedException</span><span class="p">(</span>
                    <span class="s2">&quot;Cannot read data from the stdin without specifying a format.&quot;</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="k">return</span> <span class="p">{</span>
                    <span class="s2">&quot;csv&quot;</span><span class="p">:</span> <span class="k">lambda</span> <span class="n">src</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">read_csv</span><span class="p">(</span><span class="n">src</span><span class="p">,</span> <span class="n">sep</span><span class="o">=</span><span class="s2">&quot;,&quot;</span><span class="p">),</span>
                    <span class="s2">&quot;pkl&quot;</span><span class="p">:</span> <span class="k">lambda</span> <span class="n">src</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">read_pickle</span><span class="p">(</span><span class="n">src</span><span class="p">),</span>
                    <span class="s2">&quot;xlsx&quot;</span><span class="p">:</span> <span class="k">lambda</span> <span class="n">src</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">read_excel</span><span class="p">(</span><span class="n">src</span><span class="p">)</span>
                <span class="p">}[</span><span class="n">args</span><span class="o">.</span><span class="n">ifmt</span><span class="p">]</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="c1"># Guess the format from the file extension.</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="n">ext</span> <span class="o">=</span> <span class="n">Path</span><span class="p">(</span><span class="n">args</span><span class="o">.</span><span class="n">source</span><span class="p">)</span><span class="o">.</span><span class="n">suffix</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span>
                <span class="k">return</span> <span class="p">{</span>
                    <span class="s2">&quot;.csv&quot;</span><span class="p">:</span> <span class="k">lambda</span> <span class="n">src</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">read_csv</span><span class="p">(</span><span class="n">src</span><span class="p">,</span> <span class="n">sep</span><span class="o">=</span><span class="s2">&quot;,&quot;</span><span class="p">),</span>
                    <span class="s2">&quot;.pkl&quot;</span><span class="p">:</span> <span class="k">lambda</span> <span class="n">src</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">read_pickle</span><span class="p">(</span><span class="n">src</span><span class="p">),</span>
                    <span class="s2">&quot;.xlsx&quot;</span><span class="p">:</span> <span class="k">lambda</span> <span class="n">src</span><span class="p">:</span> <span class="n">pd</span><span class="o">.</span><span class="n">read_excel</span><span class="p">(</span><span class="n">src</span><span class="p">)</span>
                <span class="p">}[</span><span class="n">Path</span><span class="p">(</span><span class="n">args</span><span class="o">.</span><span class="n">source</span><span class="p">)</span><span class="o">.</span><span class="n">suffix</span><span class="o">.</span><span class="n">lower</span><span class="p">()]</span>
            <span class="k">except</span> <span class="ne">KeyError</span><span class="p">:</span>
                <span class="k">raise</span> <span class="n">RecognizedException</span><span class="p">(</span>
                    <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="n">ext</span><span class="si">!r}</span><span class="s2"> is not a recognized input file format.&quot;</span><span class="p">)</span>
    <span class="n">logger</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Loading pandas DataFrame from </span><span class="si">{</span><span class="n">args</span><span class="o">.</span><span class="n">source</span><span class="si">!r}</span><span class="s2">.&quot;</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">get_reader</span><span class="p">()(</span><span class="n">sys</span><span class="o">.</span><span class="n">stdin</span> <span class="k">if</span> <span class="n">args</span><span class="o">.</span><span class="n">source</span> <span class="o">==</span> <span class="s2">&quot;-&quot;</span> <span class="k">else</span> <span class="n">args</span><span class="o">.</span><span class="n">source</span><span class="p">)</span></div>



<div class="viewcode-block" id="set_theme">
<a class="viewcode-back" href="../../api/plot.html#plot.plot.set_theme">[docs]</a>
<span class="k">def</span> <span class="nf">set_theme</span><span class="p">(</span><span class="n">args</span><span class="p">):</span>
    <span class="k">if</span> <span class="n">args</span><span class="o">.</span><span class="n">theme_style</span> <span class="o">==</span> <span class="s2">&quot;xkcd&quot;</span><span class="p">:</span>
        <span class="n">plt</span><span class="o">.</span><span class="n">xkcd</span><span class="p">()</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">sns</span><span class="o">.</span><span class="n">set_theme</span><span class="p">(</span>
            <span class="n">context</span><span class="o">=</span><span class="n">args</span><span class="o">.</span><span class="n">theme_context</span><span class="p">,</span>
            <span class="n">style</span><span class="o">=</span><span class="n">args</span><span class="o">.</span><span class="n">theme_style</span><span class="p">,</span>
            <span class="n">palette</span><span class="o">=</span><span class="n">args</span><span class="o">.</span><span class="n">theme_palette</span><span class="p">,</span>
            <span class="n">font</span><span class="o">=</span><span class="n">args</span><span class="o">.</span><span class="n">font</span><span class="p">)</span></div>



<div class="viewcode-block" id="create_figure_and_axes">
<a class="viewcode-back" href="../../api/plot.html#plot.plot.create_figure_and_axes">[docs]</a>
<span class="k">def</span> <span class="nf">create_figure_and_axes</span><span class="p">(</span><span class="n">args</span><span class="p">):</span>
    <span class="c1"># Creates the figure and axes, possibly in a grid.</span>
    <span class="n">num</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">args</span><span class="o">.</span><span class="n">y</span><span class="p">)</span>
    <span class="k">if</span> <span class="nb">str</span><span class="p">(</span><span class="n">args</span><span class="o">.</span><span class="n">grid</span><span class="p">)</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span> <span class="o">==</span> <span class="s2">&quot;false&quot;</span><span class="p">:</span>
        <span class="c1"># No grid: everything on one figure.</span>
        <span class="n">nrows</span><span class="p">,</span> <span class="n">ncols</span> <span class="o">=</span> <span class="mi">1</span><span class="p">,</span> <span class="mi">1</span>
    <span class="k">elif</span> <span class="nb">str</span><span class="p">(</span><span class="n">args</span><span class="o">.</span><span class="n">grid</span><span class="p">)</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span> <span class="o">==</span> <span class="s2">&quot;true&quot;</span><span class="p">:</span>
        <span class="c1"># Auto grid: As square as possible with extra rows if necessary.</span>
        <span class="n">ncols</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">num</span><span class="p">))</span>
        <span class="n">nrows</span> <span class="o">=</span> <span class="n">num</span><span class="o">//</span><span class="n">ncols</span> <span class="o">+</span> <span class="nb">int</span><span class="p">(</span><span class="n">num</span> <span class="o">%</span> <span class="n">ncols</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="c1"># User has specified the number of columns.</span>
        <span class="n">ncols</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">args</span><span class="o">.</span><span class="n">grid</span><span class="p">)</span>
        <span class="n">nrows</span> <span class="o">=</span> <span class="n">num</span><span class="o">//</span><span class="n">ncols</span> <span class="o">+</span> <span class="nb">int</span><span class="p">(</span><span class="n">num</span> <span class="o">%</span> <span class="n">ncols</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">)</span>
    <span class="n">logger</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Creating a figure with </span><span class="si">{</span><span class="n">nrows</span><span class="o">*</span><span class="n">ncols</span><span class="si">}</span><span class="s2"> panels.&quot;</span><span class="p">)</span>
    <span class="n">fig</span><span class="p">,</span> <span class="n">axes</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span>
        <span class="n">nrows</span><span class="p">,</span> <span class="n">ncols</span><span class="p">,</span>
        <span class="n">sharex</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">squeeze</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
        <span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">16</span><span class="o">*</span><span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">ncols</span><span class="p">),</span> <span class="mi">9</span><span class="o">*</span><span class="n">nrows</span><span class="o">/</span><span class="n">np</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">ncols</span><span class="p">)))</span>
    <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">ax</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">axes</span><span class="o">.</span><span class="n">flat</span><span class="p">):</span>
        <span class="k">if</span> <span class="n">i</span> <span class="o">&gt;=</span> <span class="n">num</span><span class="p">:</span>
            <span class="n">ax</span><span class="o">.</span><span class="n">get_yaxis</span><span class="p">()</span><span class="o">.</span><span class="n">set_visible</span><span class="p">(</span><span class="kc">False</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">namedtuple</span><span class="p">(</span><span class="s2">&quot;FigureAndAxes&quot;</span><span class="p">,</span> <span class="s2">&quot;fig axes&quot;</span><span class="p">)(</span><span class="n">fig</span><span class="p">,</span> <span class="n">axes</span><span class="p">)</span></div>



<div class="viewcode-block" id="despine">
<a class="viewcode-back" href="../../api/plot.html#plot.plot.despine">[docs]</a>
<span class="k">def</span> <span class="nf">despine</span><span class="p">(</span><span class="n">args</span><span class="p">):</span>
    <span class="k">if</span> <span class="n">args</span><span class="o">.</span><span class="n">despine</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">logger</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Despining axes.&quot;</span><span class="p">)</span>
        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">args</span><span class="o">.</span><span class="n">despine</span><span class="p">,</span> <span class="nb">int</span><span class="p">):</span>
            <span class="c1"># Set an offset if despine is an integer</span>
            <span class="n">sns</span><span class="o">.</span><span class="n">despine</span><span class="p">(</span><span class="n">offset</span><span class="o">=</span><span class="n">args</span><span class="o">.</span><span class="n">despine</span><span class="p">,</span> <span class="n">trim</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">opts</span> <span class="o">=</span> <span class="p">{</span><span class="n">k</span><span class="p">:</span><span class="kc">True</span> <span class="k">for</span> <span class="n">k</span> <span class="ow">in</span> <span class="n">args</span><span class="o">.</span><span class="n">despine</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot;,&quot;</span><span class="p">)</span> <span class="k">if</span> <span class="n">k</span><span class="p">}</span>
            <span class="n">logger</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Calling despine with </span><span class="si">{</span><span class="n">opts</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
            <span class="n">sns</span><span class="o">.</span><span class="n">despine</span><span class="p">(</span><span class="o">**</span><span class="n">opts</span><span class="p">)</span></div>



<div class="viewcode-block" id="scatterplot">
<a class="viewcode-back" href="../../api/plot.html#plot.plot.scatterplot">[docs]</a>
<span class="k">def</span> <span class="nf">scatterplot</span><span class="p">(</span><span class="n">args</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Generates a scatter plot and returns the resulting figure and axes for</span>
<span class="sd">    further processing.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    args : argparse.Namespace</span>
<span class="sd">        Parsed command line parameters.</span>
<span class="sd">    </span>
<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    fig, axes : matplotlib.Figure, [matplotlib.Axes]</span>
<span class="sd">        The plotted figure and </span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">df</span> <span class="o">=</span> <span class="n">load_dataframe</span><span class="p">(</span><span class="n">args</span><span class="p">)</span>
    <span class="n">set_theme</span><span class="p">(</span><span class="n">args</span><span class="p">)</span>
    <span class="n">fig</span><span class="p">,</span> <span class="n">axes</span> <span class="o">=</span> <span class="n">create_figure_and_axes</span><span class="p">(</span><span class="n">args</span><span class="p">)</span>
    <span class="c1"># Set plot-specific options</span>
    <span class="n">x</span> <span class="o">=</span> <span class="n">args</span><span class="o">.</span><span class="n">x</span>
    <span class="n">opts</span> <span class="o">=</span> <span class="p">{</span>
        <span class="s2">&quot;hue&quot;</span><span class="p">:</span> <span class="n">args</span><span class="o">.</span><span class="n">hue</span><span class="p">,</span>
        <span class="s2">&quot;size&quot;</span><span class="p">:</span> <span class="n">args</span><span class="o">.</span><span class="n">size</span><span class="p">,</span>
        <span class="s2">&quot;style&quot;</span><span class="p">:</span> <span class="n">args</span><span class="o">.</span><span class="n">style</span><span class="p">,</span>
        <span class="s2">&quot;palette&quot;</span><span class="p">:</span> <span class="n">args</span><span class="o">.</span><span class="n">palette</span>
    <span class="p">}</span>
    <span class="c1"># Plot all requested columns</span>
    <span class="n">axesIter</span> <span class="o">=</span> <span class="n">cycle</span><span class="p">(</span><span class="n">axes</span><span class="o">.</span><span class="n">flat</span><span class="p">)</span>
    <span class="k">for</span> <span class="n">y</span><span class="p">,</span> <span class="n">ax</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">args</span><span class="o">.</span><span class="n">y</span><span class="p">,</span> <span class="n">axesIter</span><span class="p">):</span>
        <span class="n">sns</span><span class="o">.</span><span class="n">scatterplot</span><span class="p">(</span><span class="n">df</span><span class="p">,</span> <span class="n">x</span><span class="o">=</span><span class="n">x</span><span class="p">,</span> <span class="n">y</span><span class="o">=</span><span class="n">y</span><span class="p">,</span> <span class="n">ax</span><span class="o">=</span><span class="n">ax</span><span class="p">,</span> <span class="o">**</span><span class="n">opts</span><span class="p">)</span>
    <span class="n">despine</span><span class="p">(</span><span class="n">args</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">namedtuple</span><span class="p">(</span><span class="s2">&quot;ScatterFigure&quot;</span><span class="p">,</span> <span class="s2">&quot;fig axes&quot;</span><span class="p">)(</span><span class="n">fig</span><span class="p">,</span> <span class="n">axes</span><span class="p">)</span></div>



<div class="viewcode-block" id="write_figure">
<a class="viewcode-back" href="../../api/plot.html#plot.plot.write_figure">[docs]</a>
<span class="k">def</span> <span class="nf">write_figure</span><span class="p">(</span><span class="n">fig</span><span class="p">,</span> <span class="n">args</span><span class="p">):</span>
    <span class="nb">format</span> <span class="o">=</span> <span class="n">args</span><span class="o">.</span><span class="n">ofmt</span>
    <span class="n">opts</span> <span class="o">=</span> <span class="p">{</span>
        <span class="s2">&quot;dpi&quot;</span><span class="p">:</span> <span class="mi">300</span><span class="p">,</span>
        <span class="s2">&quot;bbox_inches&quot;</span><span class="p">:</span> <span class="s2">&quot;tight&quot;</span>
    <span class="p">}</span>
    <span class="k">if</span> <span class="n">args</span><span class="o">.</span><span class="n">output</span> <span class="o">==</span> <span class="s2">&quot;-&quot;</span><span class="p">:</span>
        <span class="k">if</span> <span class="nb">format</span> <span class="o">==</span> <span class="s2">&quot;auto&quot;</span><span class="p">:</span>
            <span class="nb">format</span> <span class="o">=</span> <span class="s2">&quot;png&quot;</span>
        <span class="n">logger</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Saving figure to stdout in </span><span class="si">{</span><span class="nb">format</span><span class="si">!r}</span><span class="s2"> format.&quot;</span><span class="p">)</span>
        <span class="k">with</span> <span class="n">BytesIO</span><span class="p">()</span> <span class="k">as</span> <span class="n">ofs</span><span class="p">:</span>
            <span class="k">if</span> <span class="nb">format</span> <span class="o">==</span> <span class="s2">&quot;png&quot;</span><span class="p">:</span>
                <span class="n">mime</span> <span class="o">=</span> <span class="sa">b</span><span class="s2">&quot;image/png;&quot;</span>
            <span class="k">elif</span> <span class="nb">format</span> <span class="o">==</span> <span class="s2">&quot;pdf&quot;</span><span class="p">:</span>
                <span class="n">mime</span> <span class="o">=</span> <span class="sa">b</span><span class="s2">&quot;application/pdf;&quot;</span>
            <span class="n">ofs</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="n">mime</span><span class="p">)</span>
            <span class="n">fig</span><span class="o">.</span><span class="n">savefig</span><span class="p">(</span><span class="n">ofs</span><span class="p">,</span> <span class="nb">format</span><span class="o">=</span><span class="nb">format</span><span class="p">,</span> <span class="o">**</span><span class="n">opts</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">if</span> <span class="nb">format</span> <span class="o">==</span> <span class="s2">&quot;auto&quot;</span><span class="p">:</span>
            <span class="nb">format</span> <span class="o">=</span> <span class="n">Path</span><span class="p">(</span><span class="n">args</span><span class="o">.</span><span class="n">output</span><span class="p">)</span><span class="o">.</span><span class="n">suffix</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span><span class="o">.</span><span class="n">strip</span><span class="p">(</span><span class="s2">&quot;.&quot;</span><span class="p">)</span> <span class="ow">or</span> <span class="s2">&quot;png&quot;</span>
        <span class="n">logger</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Saving figure to </span><span class="si">{</span><span class="n">args</span><span class="o">.</span><span class="n">output</span><span class="si">!r}</span><span class="s2"> in </span><span class="si">{</span><span class="nb">format</span><span class="si">!r}</span><span class="s2"> format.&quot;</span><span class="p">)</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">args</span><span class="o">.</span><span class="n">output</span><span class="p">,</span> <span class="s2">&quot;wb&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">ofs</span><span class="p">:</span>
            <span class="n">fig</span><span class="o">.</span><span class="n">savefig</span><span class="p">(</span><span class="n">ofs</span><span class="p">,</span> <span class="nb">format</span><span class="o">=</span><span class="nb">format</span><span class="p">,</span> <span class="o">**</span><span class="n">opts</span><span class="p">)</span></div>



<span class="c1"># ---- CLI ----</span>
<span class="c1"># The functions defined in this section are wrappers around the main Python</span>
<span class="c1"># API allowing them to be called directly from the terminal as a CLI</span>
<span class="c1"># executable/script.</span>

<div class="viewcode-block" id="parse_args">
<a class="viewcode-back" href="../../api/plot.html#plot.plot.parse_args">[docs]</a>
<span class="k">def</span> <span class="nf">parse_args</span><span class="p">(</span><span class="n">args</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Parse command line parameters</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    args : list[str]</span>
<span class="sd">        Command line arguments to be parsed.</span>
<span class="sd">    </span>
<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    argparse.Namespace</span>
<span class="sd">        Command line parameters collected into a namespace.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="nf">action</span><span class="p">(</span><span class="n">func</span><span class="p">):</span>
        <span class="k">class</span> <span class="nc">Action</span><span class="p">(</span><span class="n">argparse</span><span class="o">.</span><span class="n">Action</span><span class="p">):</span>
            <span class="k">def</span> <span class="fm">__call__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">parser</span><span class="p">,</span> <span class="n">namespace</span><span class="p">,</span> <span class="n">value</span><span class="p">,</span> <span class="n">option_string</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
                <span class="nb">setattr</span><span class="p">(</span><span class="n">namespace</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">dest</span><span class="p">,</span> <span class="n">func</span><span class="p">(</span><span class="n">value</span><span class="p">))</span>
        <span class="k">return</span> <span class="n">Action</span>
    
    <span class="nd">@action</span>
    <span class="k">def</span> <span class="nf">try_int</span><span class="p">(</span><span class="n">x</span><span class="p">):</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="k">return</span> <span class="nb">int</span><span class="p">(</span><span class="n">x</span><span class="p">)</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">x</span>
    
    <span class="n">logger</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="s2">&quot;Parsing command line arguments.&quot;</span><span class="p">)</span>
    <span class="n">parser</span> <span class="o">=</span> <span class="n">argparse</span><span class="o">.</span><span class="n">ArgumentParser</span><span class="p">(</span>
        <span class="s2">&quot;Command line utility to generate plots. See help for subcommands for &quot;</span> \
        <span class="s2">&quot;usage.&quot;</span><span class="p">)</span>

    <span class="n">topParser</span> <span class="o">=</span> <span class="n">argparse</span><span class="o">.</span><span class="n">ArgumentParser</span><span class="p">(</span><span class="n">add_help</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
    <span class="n">topParser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;source&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;File name (or &#39;-&#39; to read from the stdin) that contains data that &quot;</span> \
             <span class="s2">&quot;can be read into a pandas DataFrame.&quot;</span>
    <span class="p">)</span>
    <span class="n">topParser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;-g&quot;</span><span class="p">,</span> <span class="s2">&quot;--grid&quot;</span><span class="p">,</span>
        <span class="n">nargs</span><span class="o">=</span><span class="s2">&quot;?&quot;</span><span class="p">,</span>
        <span class="n">action</span><span class="o">=</span><span class="n">try_int</span><span class="p">,</span>
        <span class="n">const</span><span class="o">=</span><span class="s1">&#39;true&#39;</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s1">&#39;false&#39;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Place each plot on its own axis. If not specified (or set to &quot;</span> \
             <span class="s2">&quot;</span><span class="se">\&#39;</span><span class="s2">false&#39;), then all plots are placed on one axis. If &#39;true&#39;, &quot;</span> \
             <span class="s2">&quot;then each plot is placed in a grid. If a number is provided, &quot;</span> \
             <span class="s2">&quot;that is take as the number of columns in the grid. The number &quot;</span> \
             <span class="s2">&quot;of rows will be calculated.&quot;</span>
    <span class="p">)</span>
    <span class="n">topParser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;--ifmt&quot;</span><span class="p">,</span> <span class="s2">&quot;--input-format&quot;</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;auto&quot;</span><span class="p">,</span>
        <span class="n">choices</span><span class="o">=</span><span class="p">[</span><span class="s2">&quot;auto&quot;</span><span class="p">,</span> <span class="s2">&quot;csv&quot;</span><span class="p">,</span> <span class="s2">&quot;pkl&quot;</span><span class="p">],</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;This argument is required if the input is read from the stdin, &quot;</span> \
             <span class="s2">&quot;otherwise, by default, the format is inferred from the file name.&quot;</span>
    <span class="p">)</span>
    <span class="n">topParser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;-o&quot;</span><span class="p">,</span> <span class="s2">&quot;--output&quot;</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;-&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Sets the name of the file to which the image should be written. &quot;</span> \
             <span class="s2">&quot;By default the data is written to the stdout as an HTML MIME &quot;</span> \
             <span class="s2">&quot;type suited to &#39;--ofmt&#39;. If given, the extension should &quot;</span> \
             <span class="s2">&quot;correspond to a recognized output format.&quot;</span>
    <span class="p">)</span>
    <span class="n">topParser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;--ofmt&quot;</span><span class="p">,</span> <span class="s2">&quot;--output-format&quot;</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;auto&quot;</span><span class="p">,</span>
        <span class="n">choices</span><span class="o">=</span><span class="p">[</span><span class="s2">&quot;auto&quot;</span><span class="p">,</span> <span class="s2">&quot;png&quot;</span><span class="p">,</span> <span class="s2">&quot;pdf&quot;</span><span class="p">],</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Set the output format.&quot;</span>
    <span class="p">)</span>
    <span class="n">topParser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;-v&quot;</span><span class="p">,</span> <span class="s2">&quot;--verbose&quot;</span><span class="p">,</span>
        <span class="n">dest</span><span class="o">=</span><span class="s2">&quot;loglevel&quot;</span><span class="p">,</span>
        <span class="n">action</span><span class="o">=</span><span class="s2">&quot;count&quot;</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Set the verbosity of logging messages.&quot;</span>
    <span class="p">)</span>

    <span class="c1"># parents</span>
    <span class="n">themeParser</span> <span class="o">=</span> <span class="n">argparse</span><span class="o">.</span><span class="n">ArgumentParser</span><span class="p">(</span><span class="n">add_help</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
    <span class="n">themeParser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;--despine&quot;</span><span class="p">,</span>
        <span class="n">nargs</span><span class="o">=</span><span class="s2">&quot;?&quot;</span><span class="p">,</span>
        <span class="n">action</span><span class="o">=</span><span class="n">try_int</span><span class="p">,</span>
        <span class="n">const</span><span class="o">=</span><span class="s2">&quot;&quot;</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Remove select spines from the axis. With no arguments, the top and &quot;</span> \
             <span class="s2">&quot;right spines are removed. If a number is given, then remove the &quot;</span> \
             <span class="s2">&quot;default spines and offset the remaining axes by the specified amount. &quot;</span> \
             <span class="s2">&quot;Specific spines may be removed as a comma-separated list from &quot;</span> \
             <span class="s2">&quot;the allowable options: left, right, bottom, top. For example, &quot;</span> \
             <span class="s2">&quot;&#39;--despine=left,right,top&#39; to leave only the lower (x) axis.&quot;</span>
    <span class="p">)</span>
    <span class="n">themeParser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;--font&quot;</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;serif&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Set the font family that should be used. &#39;serif&#39; and &quot;</span> \
             <span class="s2">&quot;&#39;sans-serif&#39; are guaranteed to be available. Other &quot;</span> \
             <span class="s2">&quot;system-specific fonts may also be available, e.g. &#39;Times&#39;, &quot;</span> \
             <span class="s2">&quot;&#39;Arial&#39;. Your mileage may vary.&quot;</span>
    <span class="p">)</span>
    <span class="n">themeParser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;--theme-style&quot;</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;ticks&quot;</span><span class="p">,</span>
        <span class="n">choices</span><span class="o">=</span><span class="p">[</span><span class="s2">&quot;darkgrid&quot;</span><span class="p">,</span> <span class="s2">&quot;white&quot;</span><span class="p">,</span> <span class="s2">&quot;ticks&quot;</span><span class="p">,</span> <span class="s2">&quot;whitegrid&quot;</span><span class="p">,</span> <span class="s2">&quot;xkcd&quot;</span><span class="p">],</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Set the font formatting theme.&quot;</span>
    <span class="p">)</span>
    <span class="n">themeParser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;--theme-context&quot;</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;talk&quot;</span><span class="p">,</span>
        <span class="n">choices</span><span class="o">=</span><span class="p">[</span><span class="s2">&quot;notebook&quot;</span><span class="p">,</span> <span class="s2">&quot;paper&quot;</span><span class="p">,</span> <span class="s2">&quot;poster&quot;</span><span class="p">,</span> <span class="s2">&quot;talk&quot;</span><span class="p">],</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Automatically format for different use cases. Default: &#39;talk&#39;.&quot;</span>
    <span class="p">)</span>
    <span class="n">themeParser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;--theme-palette&quot;</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="s2">&quot;dark&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Many palettes are available. These are taken from the &quot;</span> \
             <span class="s2">&quot;seaborn.color_palette (https://seaborn.pydata.org/generated/seaborn.color_palette.html#seaborn.color_palette), &quot;</span> \
             <span class="s2">&quot;which includes: bright, colorblind, dark, deep, muted, pastel. &quot;</span> \
             <span class="s2">&quot;Any named matplotlib colormap may also be used. Other recognized &quot;</span> \
             <span class="s2">&quot;colormaps are &#39;husl&#39;, &#39;ch:&lt;cubehelix arguments&gt;&#39;, &quot;</span> \
             <span class="s2">&quot;&#39;light:&lt;color&gt;&#39;, &#39;dark:&lt;color&gt;&#39;, &#39;blend:&lt;color&gt;,&lt;color&gt;&#39; or any &quot;</span> \
             <span class="s2">&quot;sequence of colors that matplotlib accepts.&quot;</span>
    <span class="p">)</span>

    <span class="n">styleParser</span> <span class="o">=</span> <span class="n">argparse</span><span class="o">.</span><span class="n">ArgumentParser</span><span class="p">(</span><span class="n">add_help</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
    <span class="n">styleParser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;--hue&quot;</span><span class="p">,</span>
        <span class="n">action</span><span class="o">=</span><span class="n">try_int</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;The name or index of the column whose values should be used to &quot;</span> \
             <span class="s2">&quot;color individual markers. Typically a continuous-value column.&quot;</span>
    <span class="p">)</span>
    <span class="n">styleParser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;--size&quot;</span><span class="p">,</span>
        <span class="n">action</span><span class="o">=</span><span class="n">try_int</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;The name or index of the column whose value should be used to &quot;</span> \
             <span class="s2">&quot;set the marker size. Typically a continuous-valued column.&quot;</span>
    <span class="p">)</span>
    <span class="n">styleParser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;--style&quot;</span><span class="p">,</span>
        <span class="n">action</span><span class="o">=</span><span class="n">try_int</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;The name or index of the column whose values will set the marker &quot;</span> \
             <span class="s2">&quot;style. This should be a categorical-valued column.&quot;</span>
    <span class="p">)</span>
    <span class="n">styleParser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;--palette&quot;</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;The color palette that should be used to color the markers. This &quot;</span> \
             <span class="s2">&quot;is typically used in conjunction with the &#39;--hue&#39; option. Any &quot;</span> \
             <span class="s2">&quot;named matplotlib colormap may be used.&quot;</span>
    <span class="p">)</span>

    <span class="n">subparsers</span> <span class="o">=</span> <span class="n">parser</span><span class="o">.</span><span class="n">add_subparsers</span><span class="p">(</span><span class="n">dest</span><span class="o">=</span><span class="s2">&quot;command&quot;</span><span class="p">)</span>
    <span class="c1"># scatter</span>
    <span class="n">scatter</span> <span class="o">=</span> <span class="n">subparsers</span><span class="o">.</span><span class="n">add_parser</span><span class="p">(</span>
        <span class="s1">&#39;scatter&#39;</span><span class="p">,</span>
        <span class="n">parents</span><span class="o">=</span><span class="p">[</span><span class="n">topParser</span><span class="p">,</span> <span class="n">themeParser</span><span class="p">,</span> <span class="n">styleParser</span><span class="p">],</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Constructs a scatter plot.&quot;</span>
    <span class="p">)</span>
    <span class="n">scatter</span><span class="o">.</span><span class="n">set_defaults</span><span class="p">(</span><span class="n">plotter</span><span class="o">=</span><span class="n">scatterplot</span><span class="p">)</span>
    <span class="n">scatter</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;x&quot;</span><span class="p">,</span>
        <span class="n">action</span><span class="o">=</span><span class="n">try_int</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Column index or name whose values are to be used as the abcissa &quot;</span> \
             <span class="s2">&quot;(X-axis) in the plots.&quot;</span>
    <span class="p">)</span>
    <span class="n">scatter</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span>
        <span class="s2">&quot;y&quot;</span><span class="p">,</span>
        <span class="n">nargs</span><span class="o">=</span><span class="s2">&quot;+&quot;</span><span class="p">,</span>
        <span class="n">action</span><span class="o">=</span><span class="n">try_int</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Column index or name whose values are to be used as the ordinate &quot;</span> \
             <span class="s2">&quot;(Y-) axes.&quot;</span>
    <span class="p">)</span>

    <span class="n">result</span> <span class="o">=</span> <span class="n">parser</span><span class="o">.</span><span class="n">parse_args</span><span class="p">(</span><span class="n">args</span><span class="p">)</span>
    <span class="n">result</span><span class="o">.</span><span class="n">loglevel</span> <span class="o">=</span> <span class="n">logging</span><span class="o">.</span><span class="n">WARNING</span> <span class="o">-</span> <span class="mi">10</span><span class="o">*</span><span class="n">result</span><span class="o">.</span><span class="n">loglevel</span>
    <span class="k">return</span> <span class="n">result</span></div>



<div class="viewcode-block" id="setup_logging">
<a class="viewcode-back" href="../../api/plot.html#plot.plot.setup_logging">[docs]</a>
<span class="k">def</span> <span class="nf">setup_logging</span><span class="p">(</span><span class="n">loglevel</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;Setup basic logging</span>

<span class="sd">    Args:</span>
<span class="sd">      loglevel (int): minimum loglevel for emitting messages</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">logformat</span> <span class="o">=</span> <span class="s2">&quot;[</span><span class="si">%(asctime)s</span><span class="s2">] </span><span class="si">%(levelname)s</span><span class="s2">:</span><span class="si">%(name)s</span><span class="s2">:</span><span class="si">%(message)s</span><span class="s2">&quot;</span>
    <span class="n">logging</span><span class="o">.</span><span class="n">basicConfig</span><span class="p">(</span>
        <span class="n">level</span><span class="o">=</span><span class="n">loglevel</span><span class="p">,</span> <span class="n">stream</span><span class="o">=</span><span class="n">sys</span><span class="o">.</span><span class="n">stdout</span><span class="p">,</span> <span class="nb">format</span><span class="o">=</span><span class="n">logformat</span><span class="p">,</span> <span class="n">datefmt</span><span class="o">=</span><span class="s2">&quot;%Y-%m-</span><span class="si">%d</span><span class="s2"> %H:%M:%S&quot;</span>
    <span class="p">)</span>
    <span class="n">logger</span><span class="o">.</span><span class="n">setLevel</span><span class="p">(</span><span class="n">loglevel</span><span class="p">)</span></div>



<div class="viewcode-block" id="main">
<a class="viewcode-back" href="../../api/plot.html#plot.plot.main">[docs]</a>
<span class="k">def</span> <span class="nf">main</span><span class="p">(</span><span class="n">args</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;Wrapper allowing :func:`fib` to be called with string arguments in a CLI fashion</span>

<span class="sd">    Instead of returning the value from :func:`fib`, it prints the result to the</span>
<span class="sd">    ``stdout`` in a nicely formatted message.</span>

<span class="sd">    Args:</span>
<span class="sd">      args (List[str]): command line parameters as list of strings</span>
<span class="sd">          (for example  ``[&quot;--verbose&quot;, &quot;42&quot;]``).</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">args</span> <span class="o">=</span> <span class="n">parse_args</span><span class="p">(</span><span class="n">args</span><span class="p">)</span>
    <span class="n">setup_logging</span><span class="p">(</span><span class="n">args</span><span class="o">.</span><span class="n">loglevel</span><span class="p">)</span>
    <span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Plot type: </span><span class="si">{</span><span class="n">args</span><span class="o">.</span><span class="n">command</span><span class="si">!r}</span><span class="s2">&quot;</span><span class="p">)</span>
    <span class="n">fig</span><span class="p">,</span> <span class="n">axes</span> <span class="o">=</span> <span class="n">args</span><span class="o">.</span><span class="n">plotter</span><span class="p">(</span><span class="n">args</span><span class="p">)</span>
    <span class="n">write_figure</span><span class="p">(</span><span class="n">fig</span><span class="p">,</span> <span class="n">args</span><span class="p">)</span>
    <span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Plotting completed.&quot;</span><span class="p">)</span></div>



<div class="viewcode-block" id="run">
<a class="viewcode-back" href="../../api/plot.html#plot.plot.run">[docs]</a>
<span class="k">def</span> <span class="nf">run</span><span class="p">():</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;Calls :func:`main` passing the CLI arguments extracted from :obj:`sys.argv`</span>

<span class="sd">    This function can be used as entry point to create console scripts with setuptools.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">main</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">argv</span><span class="p">[</span><span class="mi">1</span><span class="p">:])</span>
    <span class="k">except</span> <span class="n">RecognizedException</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
        <span class="n">logger</span><span class="o">.</span><span class="n">error</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;An error has occured: </span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">e</span><span class="p">)</span><span class="si">!r}</span><span class="s2">&quot;</span><span class="p">)</span>
        <span class="n">sys</span><span class="o">.</span><span class="n">exit</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span>
    <span class="k">except</span> <span class="ne">Exception</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
        <span class="n">logger</span><span class="o">.</span><span class="n">error</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;An unrecognized exception has occured: </span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">e</span><span class="p">)</span><span class="si">!r}</span><span class="s2">&quot;</span><span class="p">)</span>
        <span class="n">sys</span><span class="o">.</span><span class="n">exit</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span></div>



<span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s2">&quot;__main__&quot;</span><span class="p">:</span>
    <span class="c1"># ^  This is a guard statement that will prevent the following code from</span>
    <span class="c1">#    being executed in the case someone imports this file instead of</span>
    <span class="c1">#    executing it as a script.</span>
    <span class="c1">#    https://docs.python.org/3/library/__main__.html</span>

    <span class="c1"># After installing your project with pip, users can also run your Python</span>
    <span class="c1"># modules as scripts via the ``-m`` flag, as defined in PEP 338::</span>
    <span class="c1">#</span>
    <span class="c1">#     python -m plot.skeleton 42</span>
    <span class="c1">#</span>
    <span class="n">run</span><span class="p">()</span>
</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../index.html">plot</a></h1>








<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../readme.html">plot</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../readme.html#docker">Docker</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../contributing.html">Contributions &amp; Help</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../license.html">License</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../authors.html">Authors</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../changelog.html">Changelog</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../api/modules.html">Module Reference</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../index.html">Documentation overview</a><ul>
  <li><a href="../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2023, Branden Kappes.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.13</a>
      
    </div>

    

    
  </body>
</html>